<template>
  <div>
    <!-- <pre>{{ urlLinkRawData }}</pre> -->
    <!-- <pre>{{ defaults }}</pre> -->
    <!-- <pre>{{ textLinkRawData }}</pre> -->
    <inline-editor :id="path.join('.')" v-model="textLinkRawData" :read-only="config.read_only" :placeholder="textLinkPlaceholder" :class="{ 'read-only': config.read_only }" :style="{ backgroundColor: defaults && defaults.text === textLinkRawData ? '#ffa6ff' : (isFieldEdited({ node, path: [...path, 'text'] }) ? '#c3dfff' : '') }"></inline-editor>
    <inline-editor v-model="urlLinkRawData" :read-only="config.read_only" :placeholder="urlLinkPlaceholder" :class="{ 'read-only': config.read_only }" :style="{ backgroundColor: defaults && defaults.url === urlLinkRawData ? '#ffa6ff' : (isFieldEdited({ node, path: [...path, 'text'] }) ? '#c3dfff' : '') }"></inline-editor>

    <!-- <input v-model="textFieldData" :disabled="config.read_only" :style="{ backgroundColor: defaults && defaults.text === textFieldData ? '#ffa6ff' : (isFieldEdited({ node, path: [...path, 'text'] }) ? '#c3dfff' : '') }">
    <input v-model="urlFieldData" :disabled="config.read_only" :style="{ backgroundColor: defaults && defaults.url === urlFieldData ? '#ffa6ff' : (isFieldEdited({ node, path: [...path, 'url'] }) ? '#c3dfff' : '') }"> -->
  </div>
</template>

<script>
import _ from 'lodash'

import { mapActions, mapGetters } from 'vuex'

import InlineEditor from '@/components/Editable/Utils/InlineEditor'

export default {
  components: {
    InlineEditor
  },

  props: {
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: true
    },
    // config: {
    //   type: Object,
    //   required: true
    // },
    defaults: {
      required: false
    }
  },

  data () {
    return {
      rawKey: 'inner-html'
    }
  },

  computed: {
    ...mapGetters({
      getEditedField: 'Y3TI/getEditedField',
      isFieldEdited: 'Y3TI/isFieldEdited',
      getFieldConfig: 'Y3TI/getFieldConfig'
    }),

    config () {
      return this.getFieldConfig({ node: this.node, path: this.path })
    },

    textLinkPlaceholder () {
      return _.get(this.config, 'widget.form.settings.placeholder_title')
    },

    urlLinkPlaceholder () {
      return _.get(this.config, 'widget.form.settings.placeholder_url')
    },

    textLinkRawData: {
      get () {
        const data = this.getEditedField({ node: this.node, path: [...this.path, 'text'], raw: this.rawKey })
        // return data === null ? _.get(this.defaults, ['text']) : data
        return data === null ? _.get(this.defaults, ['text']) || data : data
      },
      set (value) {
        this.storeEditableFieldData({ data: { node: this.node, path: [...this.path, 'text'], input: value, raw: this.rawKey } })
      }
    },

    urlLinkRawData: {
      get () {
        const data = this.getEditedField({ node: this.node, path: [...this.path, 'url'], raw: this.rawKey })
        // return data === null ? _.get(this.defaults, ['url']) : data
        return data === null ? _.get(this.defaults, ['url']) || data : data
      },
      set (value) {
        this.storeEditableFieldData({ data: { node: this.node, path: [...this.path, 'url'], input: value, raw: this.rawKey } })
      }
    }
  },

  methods: {
    ...mapActions({
      storeEditableFieldData: 'Y3TI/storeEditableFieldData'
    })
  }
}
</script>

<style lang="scss" scoped>
  .read-only {
    border: gray solid;
    background-color: gray;
    color: white;
  }
</style>
